{
  This is basically a ported version of
  HandleList app. by someone known as Napalm
  on Sysinternals.com forums. It can display
  all open handles of all processes.

  (Not really - some handles can't be duplicated
  by DuplicateHandle, so it can't retrieve their
  type/name/whatever. However you could use DLL
  injection or something similar to analyze them, too).

  There's a lot of possible improvements I can't be
  bothered to make now :P

  More info:
  http://undocumented.ntinternals.net/
  http://www.informit.com/articles/article.asp?p=22442
  http://forum.sysinternals.com/forum_posts.asp?TID=3577&PN=3&TPN=2
  
  W-Shadow
  http://w-shadow.com/ 
}

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, Buttons, PSApi, ShellApi, uNTDefs;

type
  TfmMain = class(TForm)
    Panel1: TPanel;
    sbStatus: TStatusBar;
    bbRefresh: TBitBtn;
    mmHandles: TMemo;
    cbSkipUnnamed: TCheckBox;
    cbFilter: TComboBox;
    Label1: TLabel;
    procedure bbRefreshClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbFilterChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;
  

implementation

{$R *.dfm}

procedure TfmMain.bbRefreshClick(Sender: TObject);
var
 dwSize,dwIdx,dwX :DWORD;
 pHandleInfo :PSYSTEM_HANDLE_INFORMATION;
 ntReturn :NTSTATUS;
 temp :TStringList;
 hProcess :cardinal;
 hObject :cardinal;
 lpwsName, lpwsType, MyFilter :PWideChar;
 lpszProcess:PAnsiChar;
 s:string;
begin
 temp:=TStringList.Create;
 MyFilter:=AllocMem(length(cbFilter.Text)*2+2);
 StringToWideChar(cbFilter.text, MyFilter,
  length(cbFilter.Text)*2);
 if(@NTQuerySystemInformation<>nil) then begin
		//dwSize := sizeof(SYSTEM_HANDLE_INFORMATION);
    dwSize := 1024*1024; //a megabyte :P You can do better!
		pHandleInfo := AllocMem(dwSize);
		ntReturn := NTQuerySystemInformation(
     DWORD(SystemHandleInformation),
     pHandleInfo,
     dwSize,
     @dwX);
		if(ntReturn = STATUS_INFO_LENGTH_MISMATCH) then begin
			FreeMem(pHandleInfo);
			pHandleInfo := AllocMem(dwX);
			ntReturn := NTQuerySystemInformation(
       Cardinal(SystemHandleInformation),
       pHandleInfo, dwSize, @dwX);
		end;
		if(ntReturn = STATUS_SUCCESS) then begin
      sbStatus.simpleText:='Found '+inttostr(pHandleInfo.uCount)+
      ' handles ('+inttostr(dwX)+' bytes)';
      temp.Add(Format('  PID'#9'Handle'#9'%-19s%-18sHandle Name',
       ['Type', 'Process Name']));
      for dwIdx:=0 to pHandleInfo^.uCount-1 do begin
				hProcess := OpenProcess(
          PROCESS_DUP_HANDLE or PROCESS_QUERY_INFORMATION or
          PROCESS_VM_READ, FALSE, pHandleInfo.Handles[dwIdx].uIdProcess);
				if(hProcess <> INVALID_HANDLE_VALUE) then begin
					hObject := 0;
					if DuplicateHandle(
              hProcess,
              pHandleInfo.Handles[dwIdx].Handle,
						  GetCurrentProcess(),
              @hObject,
              STANDARD_RIGHTS_REQUIRED,
              FALSE, 0)
					then begin
						lpwsName := GetObjectInfo(hObject, ObjectNameInformation);
						if (lpwsName <> nil) or (not cbSkipUnnamed.Checked) then begin
              if(lpwsName = nil) then begin
               s:='<Unnamed>';
               lpwsName:=AllocMem(length(s)*2+2);
               StringToWideChar(s,lpwsName,length(s)*2);
              end;
							lpwsType := GetObjectInfo(hObject, ObjectTypeInformation);
							lpszProcess := AllocMem(MAX_PATH);
							if GetModuleFileNameEx(hProcess, 0,
                 lpszProcess, MAX_PATH)<>0 then
                s:=ExtractFileName(lpszProcess)
              else s:= '[System]';
              if (MyFilter='All') or
                 WideSameStr(lpwsType,MyFilter) then
              temp.Add(
               Format('%5d'#9'%6d'#9'%-19s%-18s%s',
                [pHandleInfo.Handles[dwIdx].uIdProcess,
                pHandleInfo.Handles[dwIdx].Handle,
                lpwsType+string('(')+
                  inttostr(pHandleInfo.Handles[dwIdx].ObjectType)+')',
								s,
                lpwsName])
              );
              FreeMem(lpwsName);
              FreeMem(lpwsType);
              FreeMem(lpszProcess);
						end;
						CloseHandle(hObject);
					end;
					CloseHandle(hProcess);
				end;
			end;
		end else begin
      temp.add('Error while trying to allocate'+
       ' memory for System Handle Information.');
		end;
		FreeMem(pHandleInfo);
	end else begin
   temp.add('Cannot find NtQuerySystemInformation API. '+
    'Need Windows 2000 or above.');
	end;
 mmHandles.lines.assign(temp);
 temp.Free;
 FreeMem(MyFilter);
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
 if EnableDebugPrivilege then sbStatus.SimpleText:='OK'
  else sbStatus.SimpleText:='No privileges';
end;

procedure TfmMain.cbFilterChange(Sender: TObject);
begin
 bbRefresh.Click;
end;

end.
